#ifndef _SPEED_RENDERER_H_
#define _SPEED_RENDERER_H_

#include "OpenGL.h"

#include "Map.h"
#include "Game.h"
#include "Font.h"

typedef struct PaletteEntry
{
	GLubyte r,g,b;
} PaletteEntry;

typedef struct Renderer
{
	GLuint textures[NUM_MAP_TEXTURES],lights[NUM_MAP_TEXTURES];
	PaletteEntry palette[256];
	Font font;
} Renderer;

int InitRenderer(Renderer *renderer,char *palfile);
int PrepareForMap(Renderer *renderer,Map *map);
void Render(Renderer *renderer,Map *map,struct Game *game,int animticks);

#endif
